%define anolis_release .0.1

Name: liburing
Version: 1.0.7
Release: 3%{anolis_release}%{?dist}
Summary: Linux-native io_uring I/O access library
License: LGPLv2+
Source: %{name}-%{version}.tar.bz2
URL: http://brick.kernel.dk/snaps/%{name}-%{version}.tar.bz2
BuildRequires: gcc
Patch0: liburing-always-build-with-fPIC.patch
# Begin: Anolis customized patches
Patch1001: 1001-liburing-anolis-Add-percpu-io-sq-thread-support.patch
Patch1002: 1002-liburing-anolis-Revert-Make-the-liburing-header-files-again-compatib.patch
Patch1003: 1003-liburing-anolis-Revert-src-include-liburing-barrier.h-Restore-clang-.patch
Patch1004: 1004-liburing-anolis-Revert-src-include-liburing-barrier.h-Use-C11-atomic.patch
Patch1005: 1005-liburing-anolis-sq_ring_needs_enter-revert-change-to-only-enter-if-s.patch
Patch1006: 1006-liburing-anolis-io_uring.h-update-with-5.11-pending-copy.patch
Patch1007: 1007-liburing-anolis-Include-features-in-struct-io_uring.patch
Patch1008: 1008-liburing-anolis-Add-__sys_io_uring_enter2.patch
Patch1009: 1009-liburing-anolis-Add-wrapper-for-__io_uring_get_cqe.patch
Patch1010: 1010-liburing-anolis-Use-IORING_ENTER_GETEVENTS_TIMEOUT-if-available.patch
Patch1011: 1011-liburing-anolis-Update-SIG_IS_DATA-to-modified-kernel-API.patch
Patch1012: 1012-liburing-anolis-Rename-SIG_IS_DATA-EXT_ARG.patch
Patch1013: 1013-liburing-anolis-support-async-ioctl-in-liburing.patch
Patch1014: 1014-liburing-anolis-test-timeout-new-test-for-timeout-feature.patch
Patch1015: 1015-liburing-anolis-test-use-a-map-to-define-test-files-devices-we-need.patch
Patch1016: 1016-liburing-anolis-test-add-ioctl-test.patch
Patch1017: 1017-liburing-anolis-test-timeout-overflow-don-t-run-on-newer-kernels.patch
Patch1018: 1018-liburing-anolis-support-us-granularity-of-io_sq_thread_idle.patch
Patch1019: 1019-liburing-anolis-add-IORING_ENTER_SQ_SUBMIT_ON_IDLE-flag.patch
# End: Anolis customized patches

%description
Provides native async IO for the Linux kernel, in a fast and efficient
manner, for both buffered and O_DIRECT.

%package devel
Summary: Development files for Linux-native io_uring I/O access library
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig

%description devel
This package provides header files to include and libraries to link with
for the Linux-native io_uring.

%prep
%autosetup -p1

%build
./configure --prefix=%{_prefix} --libdir=/%{_libdir} --libdevdir=/%{_libdir} --mandir=%{_mandir} --includedir=%{_includedir}

%make_build V=1

%install
%make_install

%files
%attr(0755,root,root) %{_libdir}/liburing.so.*
%doc COPYING

%files devel
%{_includedir}/liburing/
%{_includedir}/liburing.h
%{_libdir}/liburing.so
%{_libdir}/liburing.a
%{_libdir}/pkgconfig/*
%{_mandir}/man2/*

%changelog
* Mon Nov 29 2021 Hao Xu <haoxu@linux.alibaba.com> - 1.0.7-3.0.1
- add anolis customized patches to support features in Anolis OS Kernel

* Thu Aug 20 2020 Jeff Moyer <jmoyer@redhat.com> - 1.0.7-3.el8
- Build with V=1 so that the build logs are useful.
- Related: rhbz#1862551

* Thu Aug 20 2020 Jeff Moyer <jmoyer@redhat.com> - 1.0.7-2.el8
- Fix versioning.  The installed library is 1.0.7, make the rpm match.
- bump release number for build, which includes -fPIC fix
- Related: rhbz#1862551

* Fri Jul 31 2020 Jeff Moyer <jmoyer@redhat.com> - 0.7-1.el8
- Update to upstream version 0.7.
- Resolves: 1862551

* Wed Nov  6 2019 Jeff Moyer <jmoyer@redhat.com> - 0.2-2.el8
- bump release to trigger gating tests
- Related: bz#1724804

* Thu Oct 31 2019 Jeff Moyer <jmoyer@redhat.com> - 0.2-1
- Initial rhel8 package.
- Resolves: bz#1724804

* Tue Jan 8 2019 Jens Axboe <axboe@kernel.dk> - 0.1
- Initial version
